/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

hposp0	= $D000
hposp1	= $D001
hposp2	= $D002
hposp3	= $D003
hposm0	= $D004
hposm1	= $D005
hposm2	= $D006
hposm3	= $D007
sizep0	= $D008
sizep1	= $D009
sizep2	= $D00A
sizep3	= $D00B
sizem	= $D00C
colpm0	= $D012
colpm1	= $D013
colpm2	= $D014
colpm3	= $D015
color0	= $D016
color1	= $D017
color2	= $D018
color3	= $D019
colbak	= $D01A
gtictl	= $D01B
pmcntl	= $D01D
hitclr	= $D01E
skctl	= $D20F
portb	= $D301
dmactl	= $D400
dlptr	= $D402
vscrol	= $D405
pmbase	= $D407
chbase	= $D409
wsync	= $D40A
vcount	= $D40B
nmien	= $D40E
nmist	= $D40F


	org $00

fcnt	.ds 2
fadr	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1


* ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

* ---	MAIN PROGRAM
	org $2000
ant	dta $44,a(scr)
	dta $04,$04,$04,$84,$04,$04,$04,$04,$84,$84,$04,$04,$04,$04,$04,$04
	dta $04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04
	dta $41,a(ant)

scr	ins 'load4.scr'

	.ALIGN $0400
fnt	ins 'load4.fnt'

	.ifdef USESPRITES
	.ALIGN $0800
	.ds $0300
pmg	SPRITES
	eif

main
* ---	init PMG

	.ifdef USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again

	.ifdef CHANGES		;if label CHANGES defined

_lp	lda skctl		;wait to press any key; here you can put any own routine
	and #$04
	bne _lp

	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+

	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled
	jmp ($000a)		;jump to DOS

	els

null	jmp dli1		;CPU is busy here, so no more routines allowed

	eif


* ---	DLI PROGRAM

	?old_dli = *

dli1
	lda vcount
	cmp #$02
	bne dli1
	:3 sta wsync
	DLINEW dli2 1 0 0
dli_start


dli2
	lda >fnt+$400*$01
	sta wsync		;line=40
	sta chbase
	DLINEW dli3 1 0 0

dli3
	lda >fnt+$400*$02
	sta wsync		;line=80
	sta chbase
	DLINEW dli4 1 0 0

dli4
	lda >fnt+$400*$00
	sta wsync		;line=88
	sta chbase

	lda regA
	rti

;---

CHANGES

;---

.proc	NMI

	sta regA
	stx regX
	sty regY

	bit nmist
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #%00111110 dmactl	;set new screen's width

	inc cloc		;little timer

;--- first line of screen initialization

	lda >fnt+$400*$00
	sta chbase
c0	lda #$00
	sta colbak
c1	lda #$E8
	sta color0
c2	lda #$06
	sta color1
c3	lda #$0E
	sta color2
c4	lda #$00
	sta color3
	lda #$04
	sta gtictl

	mwa #dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

;---
	run main
;---

	opt l-

.MACRO	SPRITES
	.ds $100
	.ds $100
	.ds $100
	.ds $100
	.ds $100
.ENDM

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

